//+------------------------------------------------------------------+
//|                                           !Trade4me_BUY_Line.mq4 |
//|                                                     SAS NEUTRINO |
//|                                                 http://Trade4.me |
//+------------------------------------------------------------------+
#property copyright "SAS NEUTRINO"
#property link      "https://Trade4.me"
#property indicator_chart_window

#include "..\Include\!Trade4me_functions.mqh"

extern double trigger_level = 0;
extern string username      = "testusername";
extern string password      = "testpassword";
extern int    expiry        = 15;
extern double investment    = 25;

double trigger;
double prevbid;
string id;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit() 
{  
   trigger = 0; prevbid = Bid;
   id = IntegerToString(MathRand());
   if(ObjectFind(0,"trigger_level_up"+id)>=0){
      if(trigger_level>0) ObjectSetDouble(0,"trigger_level_up"+id,OBJPROP_PRICE,trigger_level);
      else ObjectSetDouble(0,"trigger_level_up"+id,OBJPROP_PRICE,Bid-Point*40);
   }
   else
   {
      if(trigger_level>0){
         ObjectCreate(0,"trigger_level_up"+id,OBJ_HLINE,0,0,trigger_level);
         ObjectSetInteger(0,"trigger_level_up"+id,OBJPROP_COLOR,Blue);
      }
      else {
         ObjectCreate(0,"trigger_level_up"+id,OBJ_HLINE,0,0,Bid-Point*40);
         ObjectSetInteger(0,"trigger_level_up"+id,OBJPROP_COLOR,Blue);
      }
   }
   return(INIT_SUCCEEDED);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   ObjectDelete(0, "trigger_level_up"+id);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
  
   ArraySetAsSeries(close,true);
   ArraySetAsSeries(open,true);
   
   if (ObjectGetDouble(0,"trigger_level_up"+id,OBJPROP_PRICE,0) != trigger)
     trigger = MathRound(ObjectGetDouble(0,"trigger_level_up"+id,OBJPROP_PRICE,0)/Point)*Point;
   
   Comment(prevbid+" "+Bid+" "+trigger);
   
   if (((prevbid > trigger && Bid <= trigger) 
   ||   (prevbid < trigger && Bid >= trigger))
   &&   (trigger > 0))
   {
      string response = trade4me(username, password, Symbol(), "UP", expiry, investment);
      Alert(response);
      ObjectSetDouble(0,"trigger_level_up"+id,OBJPROP_PRICE,0);
   }
   
   prevbid=Bid;
   return(rates_total);
}
